<?php
/**
* Plugin allow to insert Goswf player (http://www.gludion.com/go/) into Joomla articles. Joomla 1.6 native.
* @author igotoy
* @copyright igotoy and various GPL sources
* @link forum.jeudego.org
* @package Gludion SGF player
* @version 1.1
* @license GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
*/

// No direct access allowed to this file
defined( '_JEXEC' ) or die( 'Restricted access' );

// Import Joomla! Plugin library file
jimport('joomla.plugin.plugin');

//The Content plugin Gludion
class plgContentGludion extends JPlugin
{
	/**
	* Plugin that loads gludion sgf player within content
	*/

	// onPrepareContent, meaning the plugin is rendered at the first stage in preparing content for output
	public function onContentPrepare($context, &$row, &$params, $page=0 )
	{
		// simple performance check to determine whether bot should process further
		if ( JString::strpos( $row->text, 'sgf' ) === false ) {
			return true;
		}
		
		// expression to search for
		$regex = '/{sgf\s*(.*?)}/i';
		
		// check whether plugin has been unpublished
		if ( !$this->params->get( 'enabled', 1 ) ) {
			$row->text = preg_replace( $regex, '', $row->text );
			return true;
		}
		
	 	// find all instances of plugin and put in $matches
		preg_match_all( $regex, $row->text, $matches );

		// Number of plugins
	 	$count = count( $matches[0] );
		
	 	// plugin only processes if there are any instances of the plugin in the text
	 	if ( $count ) {
			// Get plugin parameters
			$sgfFolder   = $this->params->def( 'sgfFolder', 'images/stories/sgf' );
			$goswfFolder = $this->params->def( 'goswfFolder', 'scripts/gludion' );
			$background  = $this->params->def( 'background', 'FEDFB4' );
			$foreground  = $this->params->def( 'foreground', 'D86F1E' );
	 		$this->_process( $row, $matches, $count, $regex, $sgfFolder, $goswfFolder, $background, $foreground);
		}
		// No return value
	}

	// The proccessing function
	protected function _process( &$row, &$matches, $count, $regex, $sgfFolder, $goswfFolder, $background, $foreground )
	{
	 	for ( $i=0; $i < $count; $i++ )
		{
	 		$load = str_replace( '{sgf', '', $matches[0][$i] );
	 		$load = str_replace( '}', '', $load );
 			$params = explode( ",", $load );

			$player 	= $this->_load( $params, $sgfFolder, $goswfFolder, $background, $foreground );
			$row->text 	= preg_replace( '{'. $matches[0][$i] .'}', $player, $row->text );
	 	}
 
	  	// removes tags without matching anything
		$row->text = preg_replace( $regex, '', $row->text );
	}

	// The function who takes care for the 'completing' of the plugins' actions : loading sgf player
	protected function _load( $params, $sgfFolder, $goswfFolder, $background, $foreground )
	{
		$paramsCount = count( $params );

		$contents .= '<EMBED src="' . trim( $goswfFolder ) . '/goswf.swf" ';
		$contents .= 'flashVars="';
		$contents .= 'nav=' . trim( $foreground);
		$contents .= '&bg=' . trim( $background );
		$contents .= '&url=../../' . trim( $sgfFolder ) . '/' . trim( $params[0] );
		if  ( $paramsCount > 1 )
		{
			$contents .= '&move=' . $params[1];
		}
		$contents .= '" bgcolor="#ffffff"
					width="640" height="480"
					type="application/x-shockwave-flash"
					pluginspage="http://www.macromedia.com/go/getflashplayer"></EMBED>';
	
		return $contents;
	}
}
?>









